package mutivenv.test;

import java.io.File;
import java.io.IOException;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IProjectDescription;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.resources.IWorkspace;
import org.eclipse.core.resources.IWorkspaceRunnable;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.Path;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jdt.core.JavaCore;
import org.eclipse.jdt.launching.JavaRuntime;
import org.junit.Assert;
import org.junit.Test;

public class MultienvTest
{
    @Test
    public void test()
        throws Exception
    {
        IProject project = createProject();
        IJavaProject javaProject = JavaCore.create( project );
        Assert.assertNotNull( JavaRuntime.computeJREEntry( javaProject ) );
    }

    protected IProject createProject()
        throws IOException, CoreException
    {
        final IWorkspace workspace = ResourcesPlugin.getWorkspace();

        final IPath location = Path.fromOSString( new File( "project" ).getCanonicalPath() );

        final IProject project = workspace.getRoot().getProject( "project" );

        workspace.run( new IWorkspaceRunnable()
        {
            public void run( IProgressMonitor monitor )
                throws CoreException
            {
                if ( !project.exists() )
                {
                    IProjectDescription projectDescription = workspace.newProjectDescription( project.getName() );
                    projectDescription.setLocation( location );
                    project.create( projectDescription, monitor );
                    project.open( IResource.NONE, monitor );
                }
                else
                {
                    project.refreshLocal( IResource.DEPTH_INFINITE, monitor );
                }
            }
        }, null );

        return project;
    }

}
